﻿using RouteGuideContracts.BusinessLogicContracts;
using RouteGuideContracts.ViewModels;
using RouteGuideDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RouteGuide
{
    public partial class FormRouteStop : Form
    {
        private readonly List<StopViewModel>? _list;

        public FormRouteStop(IStopLogic logic)
        {
            InitializeComponent();
            _list = logic.ReadList(null);
            if (_list != null)
            {
                comboBoxStop.DisplayMember = "Name";
                comboBoxStop.ValueMember = "Id";
                comboBoxStop.DataSource = _list;
                comboBoxStop.SelectedItem = null;
            }
        }

        public int Id
        {
            get
            {
                return Convert.ToInt32(comboBoxStop.SelectedValue);
            }
            set
            {
                comboBoxStop.SelectedValue = value;
            }
        }

        public IStopModel? StopModel
        {
            get
            {
                if (_list == null)
                {
                    return null;
                }
                foreach (var elem in _list)
                {
                    if (elem.Id == Id)
                    {
                        return elem;
                    }
                }
                return null;
            }
        }

        public int Number
        {
            get { return Convert.ToInt32(textBoxNumber.Text); }
            set { textBoxNumber.Text = value.ToString(); }
        }

        private void ButtonSave_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxNumber.Text))
            {
                MessageBox.Show("Fill in Nomer", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (comboBoxStop.SelectedValue == null)
            {
                MessageBox.Show("Choose Stop", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            DialogResult = DialogResult.OK;
            Close();

        }

        private void ButtonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

    }
}
